#!/usr/bin/perl

use strict;

use DBI;
use Time::HiRes qw(gettimeofday tv_interval);

my $usr=$ENV{USER};
my $DSN = "DBI:Pg:dbname=$usr port=18008";
my $dbh1 = DBI->connect($DSN, '', '', {AutoCommit=>1,RaiseError=>0,PrintError=>0})
  or die "Connection failed par= $DSN !\n";

my $MAX_THREAD;
$MAX_THREAD=10;
my $thread_num;
my $ppid=$$;
if (@ARGV == 1)
{
  $MAX_THREAD = @ARGV[0];
}
my $MAX_SECTION=300;
my $k;
# create sections 
for(my $i=1;$i<$MAX_SECTION;$i++)
{ 
$k=$i+1;
$dbh1->do("CREATE TABLE IF NOT EXISTS t_$i PARTITION OF t(CONSTRAINT pk_t_$i PRIMARY KEY (inv, dt) ) FOR VALUES FROM ($i) TO ($k);") or die $DBI::errstr;
}
$dbh1->disconnect();


for(my $i=1;$i<$MAX_THREAD;$i++)
{ 
$thread_num=$i;

my $child=fork();
if ($child==0) 
{
  print "  Start child pid=$$  number thread=$i\n";
  sleep(1);
  last;
} elsif (undef $child) {
die   print "  fork not run\n";
} else {
print ;
}
}

if ($ppid==$$) {
# parent
# test alive postgresql
#while ((my $ctl=wait)!=-1)
while(1)
  {
  #Test 
  my $r=`pg_isready -p 18008`;
  print $r;
  sleep 5;
  #print "Child pid=$ctl done.\n";

}

exit;
}
#------------------------------
#------------------------------ child thread


my $dbh = DBI->connect($DSN, '', '', {AutoCommit=>0,RaiseError=>0,PrintError=>0})
  or die "Connection failed parameters= $DSN !\n";
print "Thread $thread_num connect.\n";
#$dbh->{AutoCommit} =1;
$dbh->do("set application_name='Thread load $thread_num'") or die $DBI::errstr;

while (1) {

#$dbh->do("BEGIN WORK") or die $DBI::errstr;
my $start_time = [ gettimeofday ];
my $cnt=0;
for (my $k=0;$k<7000;$k++)
{
$dbh->do("select set_vl($thread_num,clock_timestamp()::timestamp,0::integer);") or die $DBI::errstr;
$cnt++;
}
$dbh->do("COMMIT WORK") or die $DBI::errstr;
    my $end_time = [ gettimeofday ];
    my $elapsed = tv_interval($start_time,$end_time);

print "         Thread $thread_num load ".(1000*($elapsed/$cnt))." ms/rec \n";

}

